package hu.bme.mit.project.resources;

import org.eclipse.core.resources.ICommand;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IProjectNature;
import org.eclipse.core.runtime.CoreException;

public class BookProjectNature implements IProjectNature {

	IProject project;
	public static final String NATURE_ID="hu.bme.mit.bookmanager.nature";
	public static final String BUILDER_ID="hu.bme.mit.project.builder.counter";
	public static final String DATADIR = "data";
	public static final String OUTPUTDIR = "output";
	
	@Override
	public void configure() throws CoreException {
		IProjectDescription desc = project.getDescription();
		ICommand[] commands = desc.getBuildSpec();
		boolean found = false;

		for (int i = 0; i < commands.length; ++i) {
			if (commands[i].getBuilderName().equals(BUILDER_ID)) {
				found = true;
				break;
			}
		}
		if (!found) {
			// add builder to project
			ICommand command = desc.newCommand();
			command.setBuilderName(BUILDER_ID);
			ICommand[] newCommands = new ICommand[commands.length + 1];

			// Add it after other builders.
			System.arraycopy(commands, 0, newCommands, 0, commands.length);
			newCommands[commands.length] = command;
			desc.setBuildSpec(newCommands);
			project.setDescription(desc, null);
		}
	}

	@Override
	public void deconfigure() throws CoreException {
		IProjectDescription desc = project.getDescription();
		ICommand[] commands = desc.getBuildSpec();
		int foundID = -1;
		for (int i = 0; i < commands.length; ++i) {
			if (commands[i].getBuilderName().equals(BUILDER_ID)) {
				foundID = i;
				break;
			}
		}
		if (foundID != -1) {
			// remove builder from project
			ICommand[] newCommands = new ICommand[commands.length - 1];

			System.arraycopy(commands, 0, newCommands, 0, foundID + 1);
			System.arraycopy(commands, foundID + 1, newCommands, foundID + 1,
					commands.length - foundID);

			desc.setBuildSpec(newCommands);
			project.setDescription(desc, null);
		}
	}

	@Override
	public IProject getProject() {
		return project;
	}

	@Override
	public void setProject(IProject project) {
		this.project = project;
	}

}
